/********************************************************************
 * C Users Group (U.K) C Source Code Library File CUGLIB.013        *
 * Inquiries to: M. Houston, 36 Whetstone Clo. Farquhar Rd.         *
 * Edgbaston, Birmingham B15 2QN ENGLAND			    *
 ********************************************************************
 * File name: banner.c
 * Program name:banner 
 * Source of file: Ron Wellstead
 * Purpose: An MS-DOS copy of the UNIX utility of the same name.
 * Changes: <who what when & why major changes have been made>      
 ********************************************************************/

/*
 *
 *	@(#) banner.c 1.2 87/07/27 
 *
 *	UNIX style banner utility for dos
 *
 *	copyright (c) 1987 Ron Wellsted.
 *	This software is provided on the understanding that it is
 *	NOT to be used for commercial gain. It may be freely distributed
 *	in source or object form among amateur and hobby computer users ONLY!
 *
 *	produces big letters on stdout
 *	usage: banner [-w] message
 *		-w is an optional width, if used letters will run vertically
 *			instead of horizontally
 *	written for Microsoft C, link with setargv.obj to expand wildcards
 *
 */
#include	<fcntl.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<io.h>
#include	<stdio.h>

char	font[8192];
char	dot[128];
char	clr[128];
int 	v_mode,width,row_max,dot_max;
int	font_size;
long	font_base;

main(argc,argv)
int argc;
char *argv[];
{
	char *ptr;
	int fh,i;

	if (argc > 1)
	{
		ptr = argv[1];
		if ((*ptr == '-') || (*ptr == '/'))
		{
			ptr++;
			v_mode = ((*ptr++ == 'w') ? 1 : 0);
			if (v_mode)
			{
				width = ((*ptr != '\0') ? atoi(ptr) : 80);
			}
		}
	}
	if (argc < 2)
	{
		fprintf(stderr, "usage : banner [-wn] args ...\n");
		exit(1);
	}
	if ((fh = open("/font.sys", O_BINARY | O_RDONLY)) < 0)
	{
		perror("banner: unable to open \\font.sys");
		exit(1);
	}
	if (v_mode)
	{
		font_base = 0L;
		font_size = 8192L;
		row_max = 16;
		dot_max = 10;
		width /= row_max;
		strset(dot,'#',width);
		strset(clr,' ',width);
	}
	else
	{
		font_base = 8192;
		font_size = 2048L;
		row_max = 8;
		dot_max =8;
	}
	if ((lseek(fh,font_base,0) < 0L)
		|| (read(fh,font,font_size) != font_size))
	{
		perror("banner: \\font.sys too short");
		exit(1);
	}
	close(fh);
	i = ((v_mode) ? 2 : 1);
	while (i <argc) banner(argv[i++]);
	exit(0);
}

banner(ptr)
char *ptr;
{
	int i,j,len;

	if ((len = strlen(ptr)) == 0) return;
	if (v_mode)
	{
		for (i = 0; i < len; i++)
		{
			for (j = 0; j < dot_max; j++)
			{
				v_out(ptr[i],j);
				printf("\n");
			}
		}
		for (j = 0; j < dot_max; j++) printf("\n");
	}
	else
	{
		for (j = 0; j < row_max; j++)
		{
			for (i = 0; i < len; i++)
				h_out(ptr[i],j);
			printf("\n");
		}
		printf("\n\n");
	}
}

h_out(ch,row)
char ch;
int row;
{
	int i,d,mask;

	mask = 0x80;
	for (d = 0; d < dot_max; d++)
	{
		i = font[((ch & 0xff) * row_max) + row];
		printf("%c", (mask & i) ? '#' : ' ');
		mask >>= 1;
	}
}

v_out(ch,col)
char ch;
int col;
{
	unsigned i,*fptr;
	int r,mask;

	fptr = (unsigned *)(font);
	mask = 0x0001 << col;
	for (r = (row_max - 1); r >= 0; r--)
	{
		i = fptr[((ch & 0xff) * row_max) + r];
		printf("%s", (mask & i) ? dot : clr);
	}
}

strset(str,ch,len)
char *str,ch;
int len;
{
	register i;

	for (i = 0; i < len; str[i++] = ch);
	str[i] = '\0';
}
