/********************************************************************
 * C Users Group (U.K) C Source Code Library File CUGLIB.013        *
 * Inquiries to: M. Houston, 36 Whetstone Clo. Farquhar Rd.         *
 * Edgbaston, Birmingham B15 2QN ENGLAND			    *
 ********************************************************************
 * File name: l.c
 * Program name:l 
 * Source of file: Ron Wellstead
 * Purpose: An MS-DOS copy of the UNIX utility of the same name.
 * Changes: <who what when & why major changes have been made>      
 ********************************************************************/

/*
 *
 *	@(#) l.c 1.2 87/07/27 
 *
 *	UNIX style l utility for dos
 *
 *	copyright (c) 1987 Ron Wellsted.
 *	This software is provided on the understanding that it is
 *	NOT to be used for commercial gain. It may be freely distributed
 *	in source or object form among amateur and hobby computer users ONLY!
 *
 *	displays on stdout the directory information for the files specified.
 *	if no args given will display entire current directory.
 *	usage:	l [files...]
 *	written for Microsoft C, link with setargv.obj to expand wildcards
 */
#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/stat.h>

char buffer[256]="@(#)l.c VR 1.0.0 15 Jul 1987";
struct stat data;

main(argc,argv)
int argc;
char *argv[];
{
	char ch;
	int i,j=0;

	if (argc==1)
	{
		j=execl(argv[0],argv[0],"*.*",NULL);
		perror("l");
	}
	else if (argc==2)
	{
		if (strcmp(argv[1],".")==0)
		{
			if (getcwd(buffer,128)==NULL)
			{
				perror("l: getcwd error");
				exit(1);
			}
		}
		else strcpy(buffer,argv[1]);
		ch=buffer[strlen(buffer)-1];
		if ((ch!=':')&&(j=stat(buffer,&data)))
		{
			fprintf(stderr,"l: ");
			perror(buffer);
			j=1;
		}
		else if ((data.st_mode&S_IFDIR)||(ch==':'))
		{
			if ((ch!='\\')&&(ch!='/'))
				strcat(buffer,"\\");
			strcat(buffer,"*.*");
			j=execl(argv[0],argv[0],buffer,NULL);
		}
		else j=info(argv[1]);
	}
	else
	{
		printf("Total of %d files\n",argc-1);
		for (i=1;i<argc;i++)
		{
			j=info(argv[i]);
			if (j) break;
		}
	}
	if (j) j=1;
	exit (j);
}

info(str)
char *str;
{
	char *ptr;
	int i;
	long *lptr;

	if (stat(str,&data))
	{
		fprintf(stderr,"l: ");
		perror(str);
		return 1;
	}
	else
	{
		if (data.st_mode&S_IFDIR) putchar('d');
		else if (data.st_mode&S_IFCHR) putchar('c');
		else putchar('-');
		if (data.st_mode&S_IREAD) putchar('r');
		else putchar('-');
		if (data.st_mode&S_IWRITE) putchar('w');
		else putchar('-');
		if (data.st_mode&S_IEXEC) putchar('x');
		else putchar('-');
		printf(" %d",data.st_nlink);
		lptr=(long *)&data.st_mtime;
		ptr=(char *)ctime(lptr);
		ptr[24]='\0';
		printf("   %s %6ld %s\n",ptr,data.st_size,str);
		return 0;
	}
}
