/********************************************************************
 * C Users Group (U.K) C Source Code Library File CUGLIB.013        *
 * Inquiries to: M. Houston, 36 Whetstone Clo. Farquhar Rd.         *
 * Edgbaston, Birmingham B15 2QN ENGLAND			    *
 ********************************************************************
 * File name: wscat.c
 * Program name:wscat 
 * Source of file: Ron Wellstead
 * Purpose: cats a file stripping the high bits.
 * Changes: <who what when & why major changes have been made>      
 ********************************************************************/

/*
 *
 *	@(#) wscat.c 1.2 87/07/27 
 *
 *	UNIX style wscat utility for dos
 *
 *	copyright (c) 1987 Ron Wellsted.
 *	This software is provided on the understanding that it is
 *	NOT to be used for commercial gain. It may be freely distributed
 *	in source or object form among amateur and hobby computer users ONLY!
 *
 *	copies a wordstar file from file(s) (or stdin) to stdout, removing
 *	the high bits from all characters.
 *	usage:	wscat [files....]
 *	written for Microsoft C, link with setargv.obj to expand wildcards
 */
#include	<stdio.h>

char what[]="@(#) wscat.c VR 1.0.0 15 Jul 1987";

main(argc,argv)
int argc;
char *argv[];
{
	FILE *fp;

	if (argc==1)	/* no args; copy standard input */
		filecopy(stdin);
	else
		while (--argc>0)
			if ((fp=fopen(*++argv,"r"))==NULL) {
				fprintf(stderr,"wscat: can't open %s\n",*argv);
				exit(1);
			} else {
				filecopy(fp);
				fclose(fp);
			}
	exit(0);
}

filecopy(fp)
FILE *fp;
{
	int c;

	while ((c=getc(fp))!=EOF)
	{
		c &= 0x7f;
		switch (c) {
		case 0x1a :
		case 0x0d :
			break;
		default :
			putchar(c);
		}
	}
}
